package com.humuson.amc.client.context;

public class GlobalSessionStrategy implements SessionStrategy {
	
	private Session session;

	@Override
	public void clearSession() {
		session = null;
	}

	@Override
	public Session getSession() {
		if ( session == null ) {
			session = createEmptySession();
		}
		return session;
	}

	@Override
	public void setSession(Session session) {
		if ( session == null ) {
			throw new IllegalArgumentException("session not null");
		}
		this.session = session;
	}

	@Override
	public Session createEmptySession() {
		return new Session();
	}
}
