package com.humuson.amc.client.context;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.model.Authentication;
import com.humuson.amc.client.util.ReflectionUtil;

public class Session {
		
	public static final String SESSION_KEY = "x-auth-token";
	
	Authentication authentication;
	
	String sessionId;
	
	String baseUri;
	
	Map<String,Object> infos = new HashMap<String, Object>(); 

	public Authentication getAuthentication() {
		return authentication;
	}

	public Session setAuthentication(Authentication authentication) {
		this.authentication = authentication;
		return this;
	}

	public String getSessionId() {
		return sessionId;
	}

	public Session setSessionId(String sessionId) {
		this.sessionId = sessionId;
		return this;
	}
	
	public Session setSessionId(Map<String,String> responseHeader) {
		if ( responseHeader != null && responseHeader.containsKey(SESSION_KEY) ) {
			sessionId = responseHeader.get(SESSION_KEY);
		}
		return this;
	}

	public String getBaseUri() {
		return baseUri;
	}

	public Session setBaseUri(String baseUri) {
		this.baseUri = baseUri;
		return this;
	}
	
	public Map<String, Object> getInfos() {
		return infos;
	}

	public Session setInfos(Map<String, Object> infos) {
		this.infos = infos;
		return this;
	}

	public Map<String, String> getAuthorizeHeader() {
		
		Map<String, String> header = null;
		
		if ( sessionId != null ) {
			header = new HashMap<String, String>();
			header.put(SESSION_KEY, sessionId);
		} else if ( authentication != null ) {
			header = authentication.getAuthorizedTokenHeader();
			
		}
		
		return header;
	}
	
	public void clear() {
		sessionId = null;
	}
	
	@Override
	public String toString(){
		return ReflectionUtil.toJson(this);
	}

}
