package com.humuson.amc.client.controller;

import java.util.List;

import com.humuson.amc.client.AmcClient;
import com.humuson.amc.client.model.Response;
import com.humuson.amc.client.model.request.AndroidAppRegistRequest;
import com.humuson.amc.client.model.request.AppListRequest;
import com.humuson.amc.client.model.request.IosAppRegistRequest;
import com.humuson.amc.client.model.request.WebAppRegistRequest;
import com.humuson.amc.client.model.response.App;
import com.humuson.amc.client.util.TypeUtil;

public class AppController extends AbstractController {
	
	public AppController(AmcClient amcClient) {
		super(amcClient);
	}
	
	public Response<App> regist(AndroidAppRegistRequest request) {
		
		return httpComunicator.executePost("/api/app/android", request, App.class);
	}
	
	public Response<App> regist(IosAppRegistRequest request) {
		
		return httpComunicator.executePost("/api/app/ios", request, App.class);
	}
	
	public Response<App> regist(WebAppRegistRequest request) {
		
		return httpComunicator.executePost("/api/app/web", request, App.class);
	}
	
	public Response<List<App>> getList(AppListRequest appListRequest) {
		return httpComunicator.executeGet("/api/app", appListRequest, TypeUtil.getListType(App.class));	
	}
	
}
