package com.humuson.amc.client.controller;

import com.humuson.amc.client.AmcClient;
import com.humuson.amc.client.model.Page;
import com.humuson.amc.client.model.Response;
import com.humuson.amc.client.model.request.AudienceCreateRequest;
import com.humuson.amc.client.model.request.AudienceMultiUserRegistRequest;
import com.humuson.amc.client.model.request.AudienceRequest;
import com.humuson.amc.client.model.response.Audience;
import com.humuson.amc.client.model.response.Result;
import com.humuson.amc.client.util.TypeUtil;

public class AudienceController extends AbstractController {
	
	public AudienceController(AmcClient amcClient) {
		super(amcClient);
	}
	
	public Response<Audience> create(AudienceCreateRequest request) {
		return httpComunicator.executePost("/api/audience/create", request, Audience.class);
	}
	
	public Response<Page<Audience>> get(AudienceRequest request) {
		return httpComunicator.executePost("/api/audience/info/list", request, TypeUtil.getPageType(Audience.class));
	}

	public Response<Result> registUsers(AudienceMultiUserRegistRequest request) {
		return httpComunicator.executePost("/api/audience/users", request, Result.class);
	}
}
