package com.humuson.amc.client.controller;

import com.humuson.amc.client.AmcClient;
import com.humuson.amc.client.model.AudienceScrollResponse;
import com.humuson.amc.client.model.IteratorResponse;
import com.humuson.amc.client.model.Response;
import com.humuson.amc.client.model.request.ContactRegistRequest;
import com.humuson.amc.client.model.request.ContactRequest;
import com.humuson.amc.client.model.request.ContactTagRequest;
import com.humuson.amc.client.model.response.Result;

public class ContactController extends AbstractController {
	
	public ContactController(AmcClient amcClient) {
		super(amcClient);
	}
	
	public Response<Result> regist(ContactRegistRequest request) {
		
		return httpComunicator.executePost("/api/contacts/el", request, Result.class);
	}
	
	public Response<AudienceScrollResponse> get(final ContactRequest request) {
		
		return httpComunicator.executePost("/api/contact/list", request, AudienceScrollResponse.class);
	}
	
	public IteratorResponse<AudienceScrollResponse> getIterator(final ContactRequest request) {
		
		Response<AudienceScrollResponse> response = httpComunicator.executePost("/api/contact/list", request, AudienceScrollResponse.class);
		
		final String resScrollId = response.get().getAudienceScrollId();
		
		return new IteratorResponse<AudienceScrollResponse>(new IteratorResponse.RequestJob<AudienceScrollResponse>() {
			
			@Override
			public IteratorResponse<AudienceScrollResponse> execute() {
				ContactRequest scrollRequest = request;
				scrollRequest.setAudienceScrollId(resScrollId);
				scrollRequest.setPage(request.getPage()+1);
				return getIterator(request);
			}
			
		}, response);
	}
	
	public IteratorResponse<AudienceScrollResponse> getIterator(final ContactTagRequest request) {
		
		Response<AudienceScrollResponse> response = httpComunicator.executeGet("/api/contact/tag/list", request, AudienceScrollResponse.class);
		
		final String resScrollId = response.get().getAudienceScrollId();
		
		return new IteratorResponse<AudienceScrollResponse>(new IteratorResponse.RequestJob<AudienceScrollResponse>() {
			
			@Override
			public IteratorResponse<AudienceScrollResponse> execute() {
				ContactTagRequest scrollRequest = request;
				scrollRequest.setAudienceScrollId(resScrollId);
				scrollRequest.setPage(request.getPage()+1);
				return getIterator(request);
			}
			
		}, response);
	}
	
}
