package com.humuson.amc.client.controller;

import java.util.Map;

import com.google.gson.reflect.TypeToken;
import com.humuson.amc.client.AmcClient;
import com.humuson.amc.client.model.Page;
import com.humuson.amc.client.model.Response;
import com.humuson.amc.client.model.request.SharingBannerRequest;
import com.humuson.amc.client.model.request.SharingCostRequest;
import com.humuson.amc.client.model.request.SharingReceiveListRequest;
import com.humuson.amc.client.model.request.SharingReqListRequest;
import com.humuson.amc.client.model.response.Result;
import com.humuson.amc.client.model.response.Sharing;
import com.humuson.amc.client.model.response.UserSharingBanner;
import com.humuson.amc.client.util.TypeUtil;

public class SharingController extends AbstractController  {
	
	public SharingController(AmcClient amcClient) {
		super(amcClient);
	}
	
	public Response<Page<Sharing>> getReqList(SharingReqListRequest sharingListRequest) {
		return httpComunicator.executeGet("/api/sharing/request/list", sharingListRequest, TypeUtil.getPageType(Sharing.class));	
	}
	
	public Response<Page<Sharing>> getReceiveList(SharingReceiveListRequest sharingReceiveListRequest) {
		return httpComunicator.executeGet("/api/sharing/receive/list", sharingReceiveListRequest, TypeUtil.getPageType(Sharing.class));	
	}
	
	public Response<Map<String,UserSharingBanner>> getUserSharingBanner(SharingBannerRequest request) {
		return httpComunicator.executePost("/api/sharing/banner/info", request, new TypeToken<Map<String, UserSharingBanner>>(){}.getType());
		
	}
	
	public Response<Result> changeSharingCost(SharingCostRequest request) {
		return httpComunicator.executePost("/api/sharing/banner/cost", request, Result.class);
	}
	
	public Response<Result> sentFailCount(SharingCostRequest request) {
		return httpComunicator.executePost("/api/sharing/sent/fail", request, Result.class);
	}
}
