package com.humuson.amc.client.controller;

import java.util.List;

import com.google.gson.reflect.TypeToken;
import com.humuson.amc.client.AmcClient;
import com.humuson.amc.client.model.Response;
import com.humuson.amc.client.model.request.SubjectInfoRequest;
import com.humuson.amc.client.model.response.Result;

public class SubjectInfoController extends AbstractController  {
	
	public SubjectInfoController(AmcClient amcClient) {
		super(amcClient);
	}
	
	public Response<Result> setSubjectTargetList(SubjectInfoRequest subjectRequest) {
		return httpComunicator.executePost("/api/subject/list/target", subjectRequest, Result.class);	
	}
	
	public Response<Result> removeSubjectTargetList(SubjectInfoRequest subjectRequest) {
		return httpComunicator.executePost("/api/subject/list/target/remove", subjectRequest, Result.class);	
	}
	
	public Response<List<String>> getSubjectMatchingList(SubjectInfoRequest request) {
		return httpComunicator.executePost("/api/subject/list/matching", request, new TypeToken<List<String>>(){}.getType());
	}
}
