package com.humuson.amc.client.controller;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.AmcClient;
import com.humuson.amc.client.model.Response;
import com.humuson.amc.client.model.request.UserRegistRequest;
import com.humuson.amc.client.model.request.UserUpdateRequest;
import com.humuson.amc.client.model.response.Result;
import com.humuson.amc.client.model.response.User;

public class UserController extends AbstractController {
	
	public UserController(AmcClient amcClient) {
		super(amcClient);
	}
	
	public Response<User> get() {
		return  httpComunicator.executeGet("/auth/user", null, null, null, User.class, null);
	}
	
	public Response<User> regist(UserRegistRequest request) {
		return httpComunicator.executePost("/auth/user", request, User.class);
	}
	
	public Response<User> update(UserUpdateRequest request) {
		return httpComunicator.executePut("/auth/user", request, User.class);
	}
	
	public Response<Result> delete(String id) {
		
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("id", id);
		
		return httpComunicator.executeDelete("/auth/user", null, params, null, Result.class, null);
	}
}
