package com.humuson.amc.client.http;

import java.lang.reflect.Type;
import java.util.Map;

import com.humuson.amc.client.model.Authentication;
import com.humuson.amc.client.model.Request;
import com.humuson.amc.client.model.Response;

public interface HttpComunicator {

	public Authentication authorize();
	
	public Authentication authorize(Integer timeout);
		
	
	public <T> Response<T> executePost(String path, Request request, Type type);
	
	public <T> Response<T> executePost(String path, Map<String,String> headers, Map<String,Object> params, Integer timeout, Type type, Integer retry);
		
	
	public <T> Response<T> executeGet(String path, Request request, Type type);
	
	public <T> Response<T> executeGet(String path, Map<String,String> headers, Map<String,Object> params, Integer timeout, Type type, Integer retry);
		
	
	public <T> Response<T> executePut(String path, Request request, Type type);
	
	public <T> Response<T> executePut(String path, Map<String,String> headers, Map<String,Object> params, Integer timeout, Type type, Integer retry);
		
	
	public <T> Response<T> executeDelete(String path, Request request, Type type);
	
	public <T> Response<T> executeDelete(String path, Map<String,String> headers, Map<String,Object> params, Integer timeout, Type type, Integer retry);
	
}
