package com.humuson.amc.client.http;

import org.apache.http.HttpResponse;
import org.apache.http.client.ServiceUnavailableRetryStrategy;
import org.apache.http.protocol.HttpContext;

public class RetryStrategyHandler implements ServiceUnavailableRetryStrategy {

	int retryCount;
	
	public RetryStrategyHandler(int retryCount) {
		this.retryCount = retryCount;
	}
	
	@Override
	public boolean retryRequest(HttpResponse response, int executionCount, HttpContext context) {
		int statusCode = response.getStatusLine().getStatusCode();
		return statusCode != 200 && executionCount < retryCount;
	}

	@Override
	public long getRetryInterval() {
		return 0;
	}
	
	
}
