package com.humuson.amc.client.model;

public class IteratorResponse<T> extends Response<T> {
	
	private RequestJob<T> job;
	public Response<T> response;
	
	public IteratorResponse(RequestJob<T> job, Response<T> response) {
		this.job	= job;
		this.httpStatusCode	= response.getHttpStatusCode();
		this.msg	= response.getMsg();
		this.result	= response.get();
		this.errorCode = response.getErrorCode();
	}
	
	public IteratorResponse<T> next() {
		if ( !isSucccess() ) {
			return null;
		}
		return job.execute();
	}
	
	public static interface RequestJob<T> {
		public IteratorResponse<T> execute();
	}
}