package com.humuson.amc.client.model;

import java.util.Map;

public abstract class PageableRequest extends Request {

	/**
	 * 어떤것은 page가 1부터 시작하고, 어떤건 0부터 시작해서
	 * page차이값을 나타내는 변수를 추가함. 
	 * request가 갈때 page값은 page + pageDiff가 됨.
	 */
	protected int pageDiff = 0;
	
	protected int page = 0;
	
	protected int size = 1000;
	
	public int getPage() {
		return page;
	}
	
	public void setPage(int page) {
		this.page = page;
	}

	public int getSize() {
		return size;
	}

	public void setSize(int size) {
		this.size = size;
	}
	
	public int getPageDiff() {
		return pageDiff;
	}

	public void setPageDiff(int pageDiff) {
		this.pageDiff = pageDiff;
	}

	@Override
	public Map<String, Object> getParams() {
		
		Map<String, Object> param = super.getParams();
		
		if ( !param.containsKey("page") ) {
			param.put("page", String.valueOf(Math.max(page + pageDiff, 0)));	
		}
		
		if ( !param.containsKey("size") ) {
			param.put("size", String.valueOf(size));	
		}
		
		return param;
	}
	
}
