package com.humuson.amc.client.model;

import java.util.Map;

import com.humuson.amc.client.util.ReflectionUtil;

public class Response<T> {
	
	public static int ERROR = 500;
	public static int SUCCESS = 200;
	
	int httpStatusCode;
	String msg;
	Map<String, String> headers;
	T result;
	
	String errorCode;
	
	public Response() {
		
	}
	
	public Response(int code, String msg, T result) {
		this.httpStatusCode = code;
		this.msg = msg;
		this.result = result;
	}
	
	public int getHttpStatusCode() {
		return httpStatusCode;
	}
	public void setHttpStatusCode(int code) {
		this.httpStatusCode = code;
	}
	public String getMsg() {
		return msg;
	}
	
	public void setMsg(String msg) {
		this.msg = msg;
	}
	
	public boolean isSucccess() {
		return httpStatusCode == SUCCESS;
	}
	
	public T get() {
		return result;
	}
	
	public void set(T result) {
		this.result = result;
	}
	
	public Map<String, String> getHeaders() {
		return headers;
	}

	public void setHeaders(Map<String, String> headers) {
		this.headers = headers;
	}

	public String getErrorCode() {
		return errorCode;
	}

	public void setErrorCode(String errorCode) {
		this.errorCode = errorCode;
	}

	@Override
	public String toString() {
		return ReflectionUtil.toJson(this);
	}
}
