package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.info.Optional;
import com.humuson.amc.client.info.Required;
import com.humuson.amc.client.model.Request;
import com.humuson.amc.client.util.ValidateUtil;

public class AudienceCreateRequest extends Request {

	@Required
	String siteKey;
	
	@Optional
	String channelKey;
	
	@Required
	String name;
	
	@Optional
	String description;
			
	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}

	public String getChannelKey() {
		return channelKey;
	}

	public void setChannelKey(String channelKey) {
		this.channelKey = channelKey;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
	
	@Override
	public void validate() {
		
		ValidateUtil.checkEmptyIn(
				"siteKey", siteKey,
				"name", name);
	}

	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		params.put("channelKey", channelKey);
		params.put("name", name);
		params.put("desc", description);
				
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return false;
	}
}
