package com.humuson.amc.client.model.request;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TimeZone;

import com.humuson.amc.client.info.Required;
import com.humuson.amc.client.model.PageableRequest;
import com.humuson.amc.client.util.HttpUtil;

public class AudienceRequest extends PageableRequest {
	
	public AudienceRequest() {
		setPageDiff(1);
	}
	
	@Required
	private List<String> channelKeys = new ArrayList<String>();
	
	private String audienceName;
	
	public void addChannelKey(String channelKey) {
		channelKeys.add(channelKey);
	}
	
	public boolean removeChannelKey(String channelKey) {
		return channelKeys.remove(channelKey);
	}
	
	public void clearChannelKey() {
		channelKeys.clear();
	}
	
	public List<String> getChannelKeys() {
		return channelKeys;
	}
	
	public void setChannelKeys(List<String> channelKeys) {
		this.channelKeys = channelKeys;
	}
	
	public String getAudienceName() {
		return audienceName;
	}

	public void setAudienceName(String audienceName) {
		this.audienceName = audienceName;
	}

	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("channelKeys", HttpUtil.toListParam(channelKeys));
		params.put("audienceName", audienceName);
		
		//시간 설정
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHH");
		sdf.setTimeZone(TimeZone.getTimeZone("UTC"));
		params.put("nowDatetime", sdf.format(new Date()));
		
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return false;
	}
}
