package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.model.PageableRequest;
import com.humuson.amc.client.util.ValidateUtil;

public class B2BTargetRequest extends PageableRequest {
	
	String siteKey;
	String msgId;

	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}
	
	public String getMsgId() {
		return msgId;
	}

	public void setMsgId(String msgId) {
		this.msgId = msgId;
	}

	@Override
	public void validate() {
		ValidateUtil.checkEmpty("msg.id", msgId);
	}
	
	@Override
	protected Map<String, Object> toParams() {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("siteKey", siteKey);
		result.put("msgId", msgId);
		result.put("targetId", "b2b:target:" + msgId);
		return result;
	}

	@Override
	protected boolean isJsonContentType() {
		return true;
	}
}
