package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.info.Required;
import com.humuson.amc.client.model.PageableRequest;
import com.humuson.amc.client.util.ValidateUtil;

public class ContactTagRequest extends PageableRequest {
	
	public ContactTagRequest() {
		setPageDiff(1);
	}
	
	@Required
	private String siteKey;
	
	private String audienceScrollId;
	
	private String tag;
	
	public String getSiteKey() {
		return siteKey;
	}
	
	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}

	public String getAudienceScrollId() {
		return audienceScrollId;
	}

	public void setAudienceScrollId(String audienceScrollId) {
		this.audienceScrollId = audienceScrollId;
	}

	public String getTag() {
		return tag;
	}

	public void setTag(String tag) {
		this.tag = tag;
	}

	@Override
	public void validate() {
		
		ValidateUtil.checkEmpty("tag", tag);
		
		ValidateUtil.checkEmpty("siteKey", siteKey);
	}

	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		params.put("audienceScrollId", audienceScrollId);
		params.put("tag", tag);
		
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return false;
	}
}
