package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.info.Required;
import com.humuson.amc.client.model.Request;
import com.humuson.amc.client.util.ValidateUtil;

public class IosAppRegistRequest extends Request {
	
	@Required
	private String siteKey;
	
	private String appKey;
	
	private String appName;

	private String bundleId;

	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}
	
	public String getAppKey() {
		return appKey;
	}

	public void setAppKey(String appKey) {
		this.appKey = appKey;
	}

	public String getAppName() {
		return appName;
	}

	public void setAppName(String appName) {
		this.appName = appName;
	}

	public String getBundleId() {
		return bundleId;
	}

	public void setBundleId(String bundleId) {
		this.bundleId = bundleId;
	}
	
	@Override
	public void validate() {
		
		ValidateUtil.checkEmptyIn(
				"siteKey", siteKey,
				"appName", appName,
				"bundleId", bundleId);
	}

	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		params.put("appKey", appKey);
		params.put("appName", appName);
		params.put("bundleId", bundleId);
		
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return false;
	}
}