package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.humuson.amc.client.model.Request;
import com.humuson.amc.client.util.ValidateUtil;

public class SharingBannerRequest extends Request {
	
	String siteKey;
	
	String msgKey;
	
	/**
	 * null인 경우 자신의 사이트에 요청된 모든 sharing 리스트에세 검색
	 */
	List<Long> sharingSeqs;
	
	public List<String> userIds;
	
	/**
	 * 배너를 가져오는 것과 동시에 Sharing 이용 금액을 차감 하는 경우
	 */
	boolean useDeductPoint = true;
	
	/**
	 * 마지막 대상자 호출인지 여부
	 */
	boolean isLastTarget = false;
	
	/*
	 * 무료 템플릿 사용인 경우
	 */
	boolean isFreeTemplate = false;
	
	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}
	
	public String getMsgKey() {
		return msgKey;
	}

	public void setMsgKey(String msgKey) {
		this.msgKey = msgKey;
	}

	public List<Long> getSharingSeqs() {
		return sharingSeqs;
	}

	public void setSharingSeqs(List<Long> sharingSeqs) {
		this.sharingSeqs = sharingSeqs;
	}

	public List<String> getUserIds() {
		return userIds;
	}

	public void setUserIds(List<String> userIds) {
		this.userIds = userIds;
	}

	public boolean isUseDeductPoint() {
		return useDeductPoint;
	}

	public void setUseDeductPoint(boolean useDeductPoint) {
		this.useDeductPoint = useDeductPoint;
	}
	
	public boolean isLastTarget() {
		return isLastTarget;
	}

	public void setLastTarget(boolean isLastTarget) {
		this.isLastTarget = isLastTarget;
	}

	public boolean isFreeTemplate() {
		return isFreeTemplate;
	}

	public void setFreeTemplate(boolean isFreeTemplate) {
		this.isFreeTemplate = isFreeTemplate;
	}

	@Override
	public void validate() {
		
		ValidateUtil.checkEmptyIn(
				"siteKey", siteKey,
				"msgKey", msgKey,
				"userIds", userIds);
	}

	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		params.put("msgKey", msgKey);
		params.put("sharingSeqs", sharingSeqs);
		params.put("userIds", userIds);
		params.put("deductPoint", useDeductPoint);
		params.put("lastTarget", isLastTarget);
		params.put("freeTemplate", isFreeTemplate);
				
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return true;
	}
	
}