package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.constant.SharingStatus;
import com.humuson.amc.client.model.PageableRequest;
import com.humuson.amc.client.util.ValidateUtil;

public class SharingReceiveListRequest extends PageableRequest {

	String siteKey;
	
	SharingStatus status = SharingStatus.ACTIVATION;
	
	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}
	
	public SharingStatus getStatus() {
		return status;
	}

	public void setStatus(SharingStatus status) {
		this.status = status;
	}

	@Override
	public void validate() {
		ValidateUtil.checkEmptyIn("siteKey", siteKey);
	}
	
	@Override
	protected Map<String, Object> toParams() {
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		params.put("status", (status != null)?status.getCode():SharingStatus.ACTIVATION.getCode());
				
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return true;
	}

	
}
