package com.humuson.amc.client.model.request;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.model.PageableRequest;
import com.humuson.amc.client.util.ValidateUtil;

public class SharingReqListRequest extends PageableRequest {

	String siteKey;
	Date startDate;
	Date endDate;
	
	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}

	public Date getStartDate() {
		return startDate;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	public Date getEndDate() {
		return endDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	@Override
	public void validate() {
		ValidateUtil.checkEmptyIn("siteKey", siteKey);
	}
	
	@Override
	protected Map<String, Object> toParams() {
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		
		if ( startDate != null ) {
																																																																																																										params.put("startDate", startDate.getTime());
		}
		
		if ( endDate != null ) {
			params.put("endDate", endDate.getTime());
		}

		
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return true;
	}

	
}
