package com.humuson.amc.client.model.request;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.humuson.amc.client.model.Request;
import com.humuson.amc.client.util.ValidateUtil;

public class SiteAccessDenyRequest extends Request {
	
	private String userId;
	
	private List<String> siteKeys = new ArrayList<String>();
	
	public List<String> getSiteKeys() {
		return siteKeys;
	}

	public void setSiteKey(String siteKey) {
		addSiteKey(siteKey);
	}
	
	public void setSiteKeys(List<String> siteKeys) {
		this.siteKeys = siteKeys;
	}
	
	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	public void addSiteKey(String siteKey) {
		if ( siteKeys == null ) {
			siteKeys = new ArrayList<String>();
		}
		
		siteKeys.add(siteKey);
	}
	
	public void resetSiteKeys() {
		if ( siteKeys != null ) {
			siteKeys.clear();
		}
	}
	
	@Override
	public void validate() {
		ValidateUtil.checkEmpty("sietKeys", siteKeys);
	}

	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKeys", siteKeys);
		params.put("userId", userId);
		
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return true;
	}
}