package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.constant.BusinessType;
import com.humuson.amc.client.model.Request;
import com.humuson.amc.client.util.StringUtils;
import com.humuson.amc.client.util.ValidateUtil;

public class SiteUpdateRequest extends Request {
	
	private String siteKey;
	
	private String siteName;
	
	private String url;
	
	private BusinessType businessType;

	private boolean webFlag = true;
	
	private boolean appFlag = true;
	
	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}

	public boolean isWebFlag() {
		return webFlag;
	}

	public void setWebFlag(boolean webFlag) {
		this.webFlag = webFlag;
	}

	public boolean isAppFlag() {
		return appFlag;
	}

	public String getSiteName() {
		return siteName;
	}

	public void setSiteName(String siteName) {
		this.siteName = siteName;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public BusinessType getBusinessType() {
		return businessType;
	}

	public void setBusinessType(BusinessType businessType) {
		this.businessType = businessType;
	}

	public void setAppFlag(boolean appFlag) {
		this.appFlag = appFlag;
	}
	
	@Override
	public void validate() {
		
		ValidateUtil.checkEmpty("siteKey", siteKey);
		
		ValidateUtil.checkEmpty("siteName", siteName);
		
		if ( businessType == null ) {
			businessType = BusinessType.Unknown;
		}
		
		if ( StringUtils.isEmpty(url) ) {
			webFlag = false;
		} else {
			webFlag = true;
		}
	}

	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		params.put("siteName", siteName);
		params.put("siteUrl", url);
		params.put("businessType", businessType.getCode());
		params.put("webFlag", (webFlag)?"Y":"N");
		params.put("appFlag", (appFlag)?"Y":"N");
		
		return params;
	}

	@Override
	protected boolean isJsonContentType() {
		return false;
	}
}