package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.humuson.amc.client.model.Request;
import com.humuson.amc.client.util.ValidateUtil;

public class SubjectInfoRequest extends Request {
	
	String siteKey;
	
	String msgKey;
	
	List<String> grpIds;
	
	List<String> tags;
	
	List<String> unTags;
	
	List<String> memberIds;
	
	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}

	public String getMsgKey() {
		return msgKey;
	}

	public void setMsgKey(String msgKey) {
		this.msgKey = msgKey;
	}

	public List<String> getGrpIds() {
		return grpIds;
	}

	public void setGrpIds(List<String> grpIds) {
		this.grpIds = grpIds;
	}

	public List<String> getTags() {
		return tags;
	}

	public void setTags(List<String> tags) {
		this.tags = tags;
	}

	public List<String> getUnTags() {
		return unTags;
	}

	public void setUnTags(List<String> unTags) {
		this.unTags = unTags;
	}

	public List<String> getMemberIds() {
		return memberIds;
	}

	public void setMemberIds(List<String> memberIds) {
		this.memberIds = memberIds;
	}

	@Override
	public void validate() {
		ValidateUtil.checkEmptyIn(
				"siteKey", siteKey,
				"msgKey", msgKey
			);
	}
	
	@Override
	protected Map<String, Object> toParams() {
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		params.put("msgKey", msgKey);
		params.put("grpIds", grpIds);
		params.put("tags", tags);
		params.put("unTags", unTags);
		params.put("memberIds", memberIds);
				
		return params;
	}
	
	@Override
	protected boolean isJsonContentType() {
		return true;
	}
}
