package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.model.PageableRequest;
import com.humuson.amc.client.util.ValidateUtil;

public class TargetRequest extends PageableRequest {
	
	String siteKey;
	
	TargetForm target;

	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}

	public TargetForm getTarget() {
		return target;
	}

	public void setTarget(TargetForm target) {
		this.target = target;
	}

	@Override
	public void validate() {
		ValidateUtil.checkEmptyIn("siteKey", siteKey);
		ValidateUtil.checkEmptyIn("target", target);
		target.validate();
	}
	
	@Override
	protected Map<String, Object> toParams() {
		Map<String, Object> result = new HashMap<String,Object>();
		result.put("siteKey", siteKey);
		result.put("target", target.toRequestMap());
		return result;
	}

	@Override
	protected boolean isJsonContentType() {
		return true;
	}
	
}
