package com.humuson.amc.client.model.request;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.humuson.amc.client.model.PageableRequest;

public class TrackingLogSearchRequest extends PageableRequest {
	
	String siteKey;
	String appKey;
	Map<String,Object> match;
	Map<String,Object> noMatch;
	List<String> exist;
	List<String> includeFields;
	String timestampSort;
	Long startTimestamp;
	Long endTimestamp;
	
	public String getSiteKey() {
		return siteKey;
	}

	public void setSiteKey(String siteKey) {
		this.siteKey = siteKey;
	}

	public String getAppKey() {
		return appKey;
	}

	public void setAppKey(String appKey) {
		this.appKey = appKey;
	}

	public Map<String, Object> getMatch() {
		return match;
	}

	public void setMatch(Map<String, Object> match) {
		this.match = match;
	}

	public Map<String, Object> getNoMatch() {
		return noMatch;
	}

	public void setNoMatch(Map<String, Object> noMatch) {
		this.noMatch = noMatch;
	}

	public List<String> getExist() {
		return exist;
	}

	public void setExist(List<String> exist) {
		this.exist = exist;
	}

	public List<String> getIncludeFields() {
		return includeFields;
	}

	public void setIncludeFields(List<String> includeFields) {
		this.includeFields = includeFields;
	}
	
	public String getTimestampSort() {
		return timestampSort;
	}

	public void setTimestampSort(String timestampSort) {
		this.timestampSort = timestampSort;
	}

	public Long getStartTimestamp() {
		return startTimestamp;
	}

	public void setStartTimestamp(Date startTimestamp) {
		this.startTimestamp = startTimestamp.getTime();
	}
	
	public void setStartTimestamp(Long startTimestamp) {
		this.startTimestamp = startTimestamp;
	}

	public Long getEndTimestamp() {
		return endTimestamp;
	}
	
	public void setEndTimestamp(Date endTimestamp) {
		this.endTimestamp = endTimestamp.getTime();
	}

	public void setEndTimestamp(Long endTimestamp) {
		this.endTimestamp = endTimestamp;
	}

	@Override
	protected boolean isJsonContentType() {
		return true;
	}

	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("siteKey", siteKey);
		params.put("appKey", appKey);
		params.put("match", match);
		params.put("noMatch", noMatch);
		params.put("exist", exist);
		params.put("includeFields", includeFields);
		params.put("startTimestamp", startTimestamp);
		params.put("endTimestamp", endTimestamp);
		params.put("timestampSort", timestampSort);
		
		return params;
	}
}