package com.humuson.amc.client.model.request;

import java.util.HashMap;
import java.util.Map;

import com.humuson.amc.client.constant.TimeZone;
import com.humuson.amc.client.model.Request;
import com.humuson.amc.client.util.ValidateUtil;

public class UserRegistRequest extends Request {
	
	private String id;
	private String password;
	private String name;
	private TimeZone timezone;
	private String email;
	private String tel;
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public TimeZone getTimezone() {
		return timezone;
	}
	public void setTimezone(TimeZone timezone) {
		this.timezone = timezone;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getTel() {
		return tel;
	}
	public void setTel(String tel) {
		this.tel = tel;
	}
	
	@Override
	protected Map<String, Object> toParams() {
		
		Map<String, Object> params = new HashMap<String, Object>();
		
		params.put("id", id);
		params.put("password", password);
		params.put("name", name);
		params.put("timezone", timezone.getValue());
		params.put("email", email);
		params.put("tel", tel);
		
		return params;
	}
	
	@Override
	public void validate() {
		ValidateUtil.checkEmpty("id", id);
		ValidateUtil.checkEmpty("password", password);
		ValidateUtil.checkEmpty("name", name);
		ValidateUtil.checkEmpty("timezone", timezone);
	}

	@Override
	protected boolean isJsonContentType() {
		return false;
	}
}
