package com.humuson.amc.client.security;

import org.apache.commons.codec.binary.Base64;

import com.humuson.amc.client.exception.DecryptException;

/**
 * seed 128 bit로 암호화된 정보를 복호화하는 역활을 수행 함
 * @author hyogun
 *
 */
public class Decryptor {

	public static String FREEKEY = "Pg-s_E_n_C_k_e_y";

	public static String generateKey(String key) {

		String genKey = null;

		if( key == null ) {
			genKey = FREEKEY.substring(0,16);
		} else {

			if( key.length() > 16 ) {
				genKey = key.substring(0,16);
			} else {
				genKey = key + ( FREEKEY.substring(0,16-key.length())  );
			}
		}
		return genKey;
	}

	public static String generateKey(String key, String freeKey) {

		String genKey = null;

		if( key == null ) {
			genKey = freeKey.substring(0,16);
		} else {

			if( key.length() > 16 ) {
				genKey = key.substring(0,16);
			} else {
				genKey = key + ( freeKey.substring(0,16-key.length())  );
			}
		}
		return genKey;
	}

	public static String decrypt(String str, String userKey) {
		return decrypt(str, userKey, true);
	}

	public static String decrypt(String str, String userKey, boolean useZip) {
		if( str == null ) return null;
		String returnStr = "";
		try {
			if (userKey.length() < 16) userKey = generateKey(userKey);
			else userKey = userKey.substring(0, 16);

			byte[] dec2 = userKey==null ?
					Seed.seedDecrypt(Base64.decodeBase64(str.getBytes()))
					:Seed.seedDecrypt(Base64.decodeBase64(str.getBytes()), userKey.getBytes());

			if (useZip) {
				returnStr = Zip.unzipStringFromBytes(dec2);
			} else {

				int i;
				for (i = 0; i < dec2.length && dec2[i] != 0; i++) { }

				returnStr = new String(dec2, 0, i);
			}

		} catch (Exception e) {
			throw new DecryptException("decrypt error. str:"+str,e);
		}
		return returnStr;
	}

}
