package com.humuson.amc.client.security;


import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import org.apache.commons.codec.binary.Base64;

import com.humuson.amc.client.exception.EncryptException;
import com.humuson.amc.client.exception.NoSuchException;

/**
 * seed 128bit로 암호화를 수행함
 * @author hyogun
 *
 */
public class Encryptor {
	
	private static String FREEKEY = "Pg-s_E_n_C_k_e_y";
	
	public static String generateKey(String key) {
		
		String genKey = null;
		
		if( key == null ) {
			genKey = FREEKEY.substring(0,16);
		} else {
			
			if( key.length() > 16 ) {
				genKey = key.substring(0,16);
			} else {
				genKey = key + ( FREEKEY.substring(0,16-key.length())  );
			}
		}
		return genKey;
	}
	
	public static String encrypt(String str, String userKey) {
		return encrypt(str, userKey, "UTF-8", true);
	}
	
	public static String encrypt(String str, String userKey, boolean useZip) {
		return encrypt(str, userKey, "UTF-8", useZip);
	}
	
	public static String encrypt(String str, String userKey, String charSet) {
		return encrypt(str, userKey, "UTF-8", true);
	}
	
	public static String encrypt(String str, String userKey, String charSet, boolean useZip) {
	
		String returnStr = "";

		if( str == null || userKey == null || charSet == null ) return returnStr;
		
		if (userKey.length() < 16) userKey = generateKey(userKey);
		else userKey = userKey.substring(0, 16);
		
		try {
			byte[] enc2 = null;
			
			if (useZip) {
				byte[] enc1 = Zip.zipStringToBytes(str, charSet);
				enc2 = Seed.seedEncrypt(enc1, userKey.getBytes());
			} else {
				enc2 = Seed.seedEncrypt(str.getBytes(), userKey.getBytes());
			}

			returnStr = new String(Base64.encodeBase64(enc2), charSet);
			
		} catch(Exception e) {
			throw new EncryptException("encrypt error. str:"+str,e);
		}
		
		return returnStr;
	}
	
	public static String encryptSHA(String txt) {
	
		StringBuffer sbuf = new StringBuffer();
	     
	    MessageDigest mDigest = null;
	    
		try {
		
			mDigest = MessageDigest.getInstance("SHA-256");
		
		} catch (NoSuchAlgorithmException e) {
			throw new NoSuchException("SHA-256 Algorithm is not available",e);
		}
		
	    byte[] msgStr;
	    
		try {
			msgStr = mDigest.digest(txt.getBytes("UTF-8"));
		} catch (UnsupportedEncodingException e) {
			throw new IllegalArgumentException("Encoding failed", e);
		}
	     
	    for(int i=0; i < msgStr.length; i++) {
	        byte tmpStrByte = msgStr[i];
	        String tmpEncTxt = Integer.toString((tmpStrByte & 0xff) + 0x100, 16).substring(1);
	         
	        sbuf.append(tmpEncTxt) ;
	    }
	     
	    return sbuf.toString();
	}
}
