package com.humuson.amc.client.util;


import org.apache.commons.codec.binary.Base64;

import com.google.gson.Gson;
import com.humuson.amc.client.exception.JWTDecodeException;
import com.humuson.amc.client.model.JwtPayload;

public class JwtUtil {
	
	public static Gson gson = new Gson();
	
	static String[] splitToken(String token) throws JWTDecodeException {
        String[] parts = token.split("\\.");
        if (parts.length == 2 && token.endsWith(".")) {
            //Tokens with alg='none' have empty String as Signature.
            parts = new String[]{parts[0], parts[1], ""};
        }
        if (parts.length != 3) {
            throw new JWTDecodeException(String.format("The token was expected to have 3 parts, but got %s.", parts.length));
        }
        return parts;
    }
	
	public static JwtPayload decode(String token) {
		
		JwtPayload payload = null;
		
		try {
			
			String[] parts = splitToken(token);
			
			String payloadJson = new String(Base64.decodeBase64(parts[1]), "UTF-8");
			
			payload = gson.fromJson(payloadJson, JwtPayload.class);
			 
		} catch ( Exception e ) {
			throw new JWTDecodeException("jwt token parse error", e);
		}
		
		return payload;
	}
}
