package com.humuson.amc.client.util;

import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.util.List;
import java.util.Map;

import com.google.gson.reflect.TypeToken;
import com.humuson.amc.client.model.AudienceScrollResponse;
import com.humuson.amc.client.model.Page;

public class TypeUtil {
	
	public static Type getType(final Class<?> rawType, final Class<?> actualType) {
		return new ParameterizedType() {
			
			@Override
			public Type getRawType() {
				return rawType;
			}
			
			@Override
			public Type getOwnerType() {
				return null;
			}
			
			@Override
			public Type[] getActualTypeArguments() {
				return new Type[] {actualType};
			}
		};
	}
	
	public static Type getPageType(final Class<?> clz) {
		return getType(Page.class, clz);
	}
	
	public static Type getAudienceScrollResponseType(final Class<?> clz) {
		return getType(AudienceScrollResponse.class, clz);
	}

	public static <T> Type getListType(Class<T> clz) {
		return getType(List.class, clz);
	}
	
	public static Type getStringMapType() {
		return new TypeToken<Map<String, String>>(){}.getType();
	}
	
}
