package com.humuson.amc.client.util;

import java.util.Collection;

import com.humuson.amc.client.exception.InvalidParameterException;

public class ValidateUtil {
	
	@SuppressWarnings("rawtypes")
	private static boolean isEmpty(Object obj) {
		
		if ( obj == null ) {
			return true;
		}
		
		if ( obj instanceof String ) {
			
			if ( StringUtils.isEmpty((String)obj) ) {
				return true;
			}
			
		} else if ( obj instanceof Collection ) {
			
			Collection col = (Collection)obj;
			
			if ( col.size() == 0 ) {
				return true;
			}
			
			for ( Object o : col ) {
				
				if ( isEmpty(o) ) {
					return true;
				}
			}
			
		} else if ( obj instanceof String[] ) {
			
			String[] arr = (String[]) obj;
			
			if ( arr.length == 0 ) {
				return true;
			}
			
			for ( Object o : arr ) {
				
				if ( isEmpty(o) ) {
					return true;
				}
			}
			
		}
		
		return false;
		
	}
	
	public static void checkEmpty(String name, Object obj) {
		
		if ( isEmpty(obj) ) {
			throw new InvalidParameterException(name+" is empty");
		}
	}
	
	public static void checkEmptyIn(Object ...nameValues) {
		
		if ( nameValues == null || nameValues.length == 0 || nameValues.length % 2 != 0 ) {
			return;
		}
		
		for ( int i=0,j=nameValues.length; i<j; i+=2 ) {
			checkEmpty(nameValues[i].toString(),nameValues[i+1]);
		}		
	}
	
	public static void checkEmptyAll(Object ...nameValues) {
		
		if ( nameValues == null || nameValues.length == 0 || nameValues.length % 2 != 0 ) {
			return;
		}
		
		StringBuilder sb = new StringBuilder();
		sb.append("One of ");
		
		for ( int i=0,j=nameValues.length; i<j; i+=2 ) {
			
			sb.append(nameValues[i].toString()).append(", ");
			
			if ( !isEmpty(nameValues[i+1]) ) {
				return;
			}
		}
		
		throw new InvalidParameterException(sb.append(" must not be empty").toString());
	}
}
